from __future__ import annotations
from typing import Any, Protocol, runtime_checkable
from com.sun.star.lang import XComponent

@runtime_checkable
class XController(XComponent, Protocol):
    def attachFrame(self, Frame: XFrame) -> None: ...
    def attachModel(self, Model: XModel) -> bool: ...
    def suspend(self, Suspend: bool) -> bool: ...
    def getViewData(self) -> Any: ...
    def restoreViewData(self, Data: Any) -> None: ...
    def getModel(self) -> XModel: ...
    def getFrame(self) -> XFrame: ...
